/*nauta: serial browser for Palm
  Copyright (C) 2002 D.T.Ineiev, super V 93
  This program is under the GNU GPL v2*/
#include"InitScreen.h"
#include"screen.h"
#include<PalmOS.h>
static UInt32 width,height,depth,supporteddepths;static Boolean colorEn=0;
static UInt32 OSVer;
static IndexedColorType defColor,okColor,welcomeColor,failColor,warnColor;
static void empty(int x){};static void setc_(int x){WinSetTextColor(x);}
static void (*setcol)(int);
Err InitScreen(void)
{Err err;
 FtrGet(sysFtrCreator,sysFtrNumROMVersion,&OSVer);setcol=empty;
 err=WinScreenMode(winScreenModeGet,&width,&height,&depth,&colorEn);
 if(err==memErrNotEnoughSpace)return err;
 err=WinScreenMode(winScreenModeGetSupportedDepths,0,0,&supporteddepths,0);
 if(err==memErrNotEnoughSpace)return err;
 if(colorEn)
 {defColor=95;okColor=193;welcomeColor=52;failColor=124;warnColor=141;
  setcol=setc_;
 }else if(supporteddepths&0x8)
 {defColor=8;okColor=4;welcomeColor=14;failColor=16;warnColor=12;depth=0x8;
  WinScreenMode(winScreenModeSet,&width,&height,&depth,&colorEn);
 }else{defColor=1;okColor=1;welcomeColor=1;failColor=1;warnColor=1;}
 return 0;
}
int ColorEnabled(void){return colorEn;}int ScreenDepth(void){return depth;}
int ScreenWidth(void){return width;}int ScreenHeight(void){return height;}
int ScreenSupportedDepths(void){return supporteddepths;}
void SetDefaultColor(void){setcol(defColor);}
void SetOkColor(void){setcol(defColor);}
void SetFailColor(void){setcol(failColor);}
void SetWelcomeColor(void){setcol(welcomeColor);}
void SetWarnColor(void){setcol(warnColor);} 
void SetFieldsColor(int q)
{IndexedColorType c;RGBColorType r;if(!colorEn)return;
 switch(q)
 {case 0:case 1:case 2:case 3:case 6:c=failColor;break;
  case 4:case 7:c=warnColor;break;case 8:c=okColor;break;
  default:c=defColor;break;
 }WinIndexToRGB(c,&r);UIColorSetTableEntry(UIObjectForeground,&r);
}
void ResetFieldsColor(void)
{RGBColorType r;if(!colorEn)return;WinIndexToRGB(230,&r);
 UIColorSetTableEntry(UIObjectForeground,&r);
}
