/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"start.h"
#include"GotoForm.h"
#include"events.h"
#include"FieldFunc.h"
#include"nautaAlerts.h"
#include"nautaForms.h"
#include"nautaStr.h"
#include"Init.h"
#include"screen.h"
#include<PalmOS.h>
#define hic __attribute__ ((section("nauta")))
static void srmerrexpl(Err err,int y)hic;static void srmerrexpl(Err err,int y)
{char s[68];
 switch(err)
 {case serErrAlreadyOpen:DrawStrRes(s,kidStrPortBusy,5,y);break;
  case serErrBadPort:DrawStrRes(s,kidStrBadPort,5,y);break;
  case memErrNotEnoughSpace:DrawStrRes(s,kidStrNoMem,5,y);break;
 }
}
static void clearscreen(void)hic;static void clearscreen(void)
{struct RectangleType r={0,0,160,160};WinEraseRectangle(&r,0);}
#define OK(a) {SetOkColor();WinDrawChars(Ok,tOk,120,a);}
#define FAIL(a) {SetFailColor();WinDrawChars(Fail,tFail,120,a);}
static UInt32 OSVer;
static void delay(void)hic;static void delay(void){FrmAlert(kidAlertFail);}
UInt32 Start(void)
{char s[68],Fail[10],Ok[10],y;UInt32 t,tOk,tFail;Err err;
 DrawStrRes(s,kidStrWelcome,20,1);DrawStrRes(s,kidStrCheckOS,5,y=15);
 tOk=GetStrResource(Ok,kidStrOk);tFail=GetStrResource(Fail,kidStrFail);
 FtrGet(sysFtrCreator,sysFtrNumROMVersion,&OSVer); 
 if(OSVer<sysMakeROMVersion(3,3,0,sysROMStageRelease,0))
 {WinDrawChars(Fail,tFail,120,y);delay();return 5;}WinDrawChars(Ok,tOk,120,y);
 DrawStrRes(s,kidStrGetScreen,5,y+=12);err=InitScreen();
 if(err&&err!=17){FAIL(y);delay();return 4;}
 if(err==17)DrawStrRes(s,kidStrCant,120,y);
 if(!err)
 {SetWelcomeColor();DrawStrRes(s,kidStrWelcome,20,1);
  SetDefaultColor();DrawStrRes(s,kidStrCheckOS,5,y=15);OK(y);
  SetDefaultColor();DrawStrRes(s,kidStrGetScreen,5,y+=12);OK(y);
 }SetDefaultColor();DrawStrRes(s,kidStrReadPrefs,5,y+=12);
 if(ReadPrefs()){SetWarnColor();DrawStrRes(s,kidStrFound,120,y);}else OK(y);
 NavInit();SetDefaultColor();DrawStrRes(s,kidStrLook4Ser,5,y+=12);
 if(FtrGet(sysFileCSerialMgr,sysFtrNewSerialPresent,&t))
 {SetFailColor();DrawStrRes(s,kidStrNotFound,120,y);delay();return 3;}
 SetOkColor();DrawStrRes(s,kidStrFound,120,y);y+=12;
 SetDefaultColor();DrawStrRes(s,kidStrSetSer,5,y);
 if(err=InitSerial()){FAIL(y);srmerrexpl(err,y+=12);delay();return 1;}OK(y);
 SetDefaultColor();DrawStrRes(s,kidStrInitTimer,5,y+=12);
 if(err=InitTimer()){FAIL(y);delay();CloseSerial();return 5;}OK(y);
 SetDefaultColor();DrawStrRes(s,kidStrOpenDb,5,y+=12);
 switch(InitDbNmea())
 {case 0:OK(y);break;
  case 1:SetWarnColor();DrawStrRes(s,kidStrNotFound,120,y);break;
  case 2:SetWarnColor();DrawStrRes(s,kidStrCant,120,y);break;
 }SetDefaultColor();DrawStrRes(s,kidStrOpenLog,5,y+=12);
 if(err=InitLogDb(y+12))
 {FAIL(y);delay();CloseDbNmea();CloseSerial();CloseTimer();return err;}
 OK(y);SysTaskDelay(100);clearscreen();AddMenuEvt(kidMenu);return 0;
}
void Stop(void)
{FrmCloseAllForms();CloseSerial();CloseLogDb();
 CloseDbNmea();SavePrefs();CloseTimer();
}
