/*nauta: serial browser for Palm
  Copyright (C) 2002 D.T.Ineiev, super V 93
  This program is under the GNU GPL v2*/
#include"FormHelp.h"
#include"events.h"
#include"nautaButtons.h"
#include"nautaForms.h"
#include<PalmOS.h>
static FormType*f;static char*s;static UInt16 n0,len,height,limit;
static int master;static FontID fi;static const int width=130;
static void clrscrn(void)
{static struct RectangleType r={{3,13},{150,138-13}};WinEraseRectangle(&r,0);}
static void goforth(int v,int l)
{UInt16 n=!0,j;if(v)clrscrn();
 for(j=13;j<limit&&n0<l&&n;j+=height,n0+=n)
 {n=FntWordWrap(s+n0,width);if(v)WinDrawChars(s+n0,s[n0+n-1]<=' '?n-1:n,4,j);}
}
static void draw(){if(!s)return;if(n0>=len)return;goforth(!0,len);}
static void GetRsc(int k)
{int n;MemHandle h;MemPtr p;h=DmGetResource('tSTR',k);
 p=MemHandleLock(h);n=MemPtrSize(p);s=MemPtrNew(n);MemMove(s,p,n);
 MemHandleUnlock(h);DmReleaseResource(h);len=StrLen(s);draw();
}
static void back(void)
{UInt16 l=n0,p,q;if(!(n0&&s))return;
 for(q=p=n0=0;n0<l;){q=p;p=n0;goforth(0,l);}n0=q;goforth(p!=q,l);
}
static void OnExit(void){FntSetFont(fi);if(s)MemPtrFree(s);}
static void OnEnter(EventType*e)
{f=FrmGetFormPtr(e->data.frmOpen.formID);FrmSetActiveForm(f);FrmDrawForm(f);
 fi=FntSetFont(boldFont);s=0;AddUserEvt(hlprdyEvt);master=-1;
 height=FntLineHeight();limit=138-height-2;n0=0;
}
Boolean HelpFormHandler(EventType*e)
{switch(e->eType)
 {case ctlSelectEvent:
   switch(e->data.ctlSelect.controlID)
   {case kidNext:draw();break;case kidBack:back();break;
    case kidDone:AddMenuEvt(master<0?kidMenu:master);break;
   }break;
  case keyDownEvent:
   switch(((struct _KeyDownEventType*)(&(e->data)))->chr)
   {case 12:draw();break;case 11:back();break;
    case 261:AddMenuEvt(master<0?kidMenu:master);
   }break;
  case frmOpenEvent:OnEnter(e);break;case frmCloseEvent:OnExit();break;
  case helpEvt:master=e->screenY;GetRsc(e->screenX);break;
 }return 0;
}
