/*nauta: serial browser for Palm
  Copyright (C) 2002 D.T.Ineiev, super V 93
  This program is under the GNU GPL v2*/
#include"InitSerial.h"
#include"serial.h"
#include"events.h"
#include"log.h"
#include"prefs.h"
#include<PalmOS.h>
#define bsize   4096
#define BufSize 4096 
static UInt16 port;static char Buf[BufSize],sbuf[bsize];
static int cauda=0,caput=0;
void ProcessSerial(void)
{static Err e;static UInt32 n,k,N=0;int vex=!0;
 do 
 {if(SrmReceiveCheck(port,&n))break;if(!n)break;vex=0;k=BufSize-caput;N+=n;
  if(n>=k){SrmReceive(port,Buf+caput,k,0,&e);caput=0;}else k=0;
  if(n>k){SrmReceive(port,Buf+caput,n-k,0,&e);caput+=n-k;}
 }while(n);
#ifdef DIAG
 {void SetN(int);SetN(N);}
#endif
if(N>GetRxRate()/102||(vex&&N)){AddUserEvt(serEvt);N=0;}
}static char rec[1024];static int irec=0;
int Receive(char*s)
{if(cauda==caput)return 0;rec[irec++]=*s=Buf[cauda++];
 if(irec==1024){irec=0;if(LogEnabled())logpacket(rec,1024);}
 if(cauda>=BufSize)cauda=0;return 1;
}
Err InitSerial(void)
{Err err=SrmOpen(0x8000,GetRxRate(),&port);UInt32 serflags=GetSerFlags();
 UInt16 s=4;if(err)return err;err=SrmSetReceiveBuffer(port,sbuf,bsize);
 if(err)goto x;err=SrmControl(port,srmCtlSetFlags,&serflags,&s);if(err)goto x;
 x:if(err)SrmClose(port);return err;
}
void CloseSerial(void)
{SrmSetReceiveBuffer(port,0,0);SrmClose(port);
 if(LogEnabled()&&irec)logpacket(rec,irec);
}
